import javax.imageio.ImageIO;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import java.io.*;
import java.util.*;
import java.awt.*;

import javax.swing.ButtonGroup;
import javax.swing.JMenu;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.WindowConstants; //import javax.swing.JScrollBar;
import java.awt.Dimension;
import java.awt.BorderLayout;
import java.awt.event.WindowListener;
import java.awt.image.PixelGrabber;
import java.awt.image.RenderedImage;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import javax.swing.JLabel;

/**
 * Created on 08.04.2004
 * 
 * @author Markus Bttcher first of all Measure was a stand-alone program
 */
public class Measure extends JFrame {
	private static final long serialVersionUID = 1L;

	private File currentPath = null;

	private File config = null;

	private boolean saveXY = false;

	private boolean serieGeladen = false;

	private boolean multiImage = false;

	private File[] bilder = null;

	private File letztesBild = null;

	private GregorianCalendar gc = null;

	private Calibration kalibrierung = null;

	File geladenesBild = null;

	String Dateiname = null;

	String Pfad = null;

	private JFileChooser jFileChooser = null;

	private javax.swing.JPanel jContentPane = null;

	private MyJScrollPane myjScrollPane = null;

	private JScrollPane jScrollPane2 = null;

	private javax.swing.JPanel jPanel = null;

	private javax.swing.JButton jButton = null;

	private javax.swing.JTextArea jTextArea = null;

	private javax.swing.JScrollPane jScrollPane = null;

	private javax.swing.JButton jButton1 = null;

	private javax.swing.JButton jButton2 = null;

	private javax.swing.JButton jButton3 = null;

	private javax.swing.JPanel jPanel1 = null;

	// @jve:visual-info decl-index=0 visual-constraint="9,464"
	private javax.swing.JTextField jTextField = null;

	private javax.swing.JTextField jTextField1 = null;

	private javax.swing.JLabel jLabel = null;

	private javax.swing.JLabel jLabel1 = null;

	private javax.swing.JPanel jPanel2 = null;

	private javax.swing.JTextField jTextField2 = null;

	private javax.swing.JTextField jTextField3 = null;

	private javax.swing.JMenuBar jJMenuBar = null;

	private javax.swing.JButton jButton4 = null;

	private javax.swing.JMenu jMenu3 = null;

	private javax.swing.JMenuItem jMenuItem18 = null;

	private javax.swing.JFrame jFrame = null;

	// @jve:visual-info decl-index=0 visual-constraint="609,141"
	private javax.swing.JPanel jContentPane1 = null;

	private javax.swing.JTabbedPane jTabbedPane = null;

	private javax.swing.JPanel jPanel3 = null;

	private javax.swing.JTextField jTextField4 = null;

	private javax.swing.JLabel jLabel4 = null;

	private javax.swing.JLabel jLabel5 = null;

	private javax.swing.JTextField jTextField5 = null;

	private javax.swing.JButton jButton5 = null;

	private javax.swing.JPanel jPanel4 = null;

	private javax.swing.JButton jButton6 = null;

	private javax.swing.JPanel jPanel5 = null;

	private javax.swing.JCheckBox jCheckBox1 = null;

	private javax.swing.JCheckBox jCheckBox2 = null;

	private javax.swing.JPanel jPanel6 = null;

	private javax.swing.JLabel jLabel6 = null;

	private javax.swing.JTextField jTextField6 = null;

	private javax.swing.JButton jButton7 = null;

	private JMenu jMenu = null;

	private JLabel jXAxis = null;

	private JLabel jYAxis = null;

	/**
	 * This method initializes jMenu
	 * 
	 * @return javax.swing.JMenu
	 */
	private JMenu getJMenu() {
		if (jMenu == null) {
			jMenu = new JMenu();
			jMenu.setText("calibrate system");
			jMenu.add(getJPanel1());
		}
		return jMenu;
	}

	// public static void main(String[] args) {
	// Measure a = new Measure();
	// }

	/**
	 * This is the default constructor
	 */
	public Measure() {
		super();
		initialize();
	}

	/**
	 * constructor for external program start multi image use
	 * 
	 * @param x
	 */
	public Measure(File[] bilder) {
		super();
		initialize();
		jButton4.setVisible(false);
		jButton1.setVisible(false);

		multiImage = true;
		this.bilder = bilder;
		geladenesBild = this.bilder[0];
		letztesBild = this.bilder[this.bilder.length - 1];
		myjScrollPane.setMultiFile(this.bilder);
		setTitle("actual image: " + geladenesBild.getName());
		Dateiname = geladenesBild.getName().substring(0,
				geladenesBild.getName().toString().length() - 4);
		// System.out.println("geladenes Bild " + Dateiname);
		Pfad = geladenesBild.getParent();
		// System.out.println("Pfad: " + Pfad);
		myjScrollPane.setImage(geladenesBild.toString(), Dateiname);
		myjScrollPane.setSize(myjScrollPane.getPreferredSize());
		myjScrollPane.repaint();
		serieGeladen = true;
		jCheckBox2.setEnabled(true);
		jCheckBox2.setSelected(true);
		jButton7.setEnabled(true);
	}

	public Measure(File bild) {
		super();
		initialize();
		jButton4.setVisible(false);
		jButton1.setVisible(false);
		geladenesBild = bild;
		setTitle("actual image: " + geladenesBild.getName());
		Dateiname = geladenesBild.getName().substring(0,
				geladenesBild.getName().toString().length() - 4);
		// System.out.println("geladenes Bild " + Dateiname);
		Pfad = geladenesBild.getParent();
		// System.out.println("Pfad: " + Pfad);
		myjScrollPane.setImage(geladenesBild.toString(), Dateiname);
		myjScrollPane.setSize(myjScrollPane.getPreferredSize());
		myjScrollPane.repaint();
		jButton7.setEnabled(true);
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(600, 600);
		this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		this.setContentPane(getJContentPane());
		this.setJMenuBar(getJJMenuBar());
		this
				.setTitle("1. load image; 2. calibrate; 3. save values; 4. save image");
		jFrame = getJFrame();
		this.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				jFrame.dispose();
				myjScrollPane.jFrame.dispose();
				dispose();
			}
		});
		myjScrollPane.ausgabeFenster(jTextArea);
		// myjScrollPane.setListener(this.getWindowListeners());
		gc = new GregorianCalendar();
		this.loadDefault();
		int width = this.getToolkit().getScreenSize().width;
		int height = this.getToolkit().getScreenSize().height;
		int infow = myjScrollPane.jFrame.getWidth();
		myjScrollPane.jFrame.setLocation(0, 80);
		this.setSize(width - infow, height - 40);
		this.setLocation(infow, 0);
		this.setVisible(true);
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(new java.awt.BorderLayout());
			jContentPane.add(getJPanel(), BorderLayout.NORTH);
			jContentPane.add(getJScrollPane2(), java.awt.BorderLayout.EAST);
			jContentPane.add(getJScrollPane(), java.awt.BorderLayout.CENTER);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private MyJScrollPane getmyJScrollPane() {
		if (myjScrollPane == null) {
			myjScrollPane = new MyJScrollPane(this);
			myjScrollPane.setViewportBorder(javax.swing.BorderFactory
					.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
			myjScrollPane.setBorder(javax.swing.BorderFactory
					.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
			myjScrollPane
					.setHorizontalScrollBarPolicy(javax.swing.JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
			myjScrollPane
					.setVerticalScrollBarPolicy(javax.swing.JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
		}
		return myjScrollPane;
	}

	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new javax.swing.JPanel();
			jPanel.add(getJButton4(), null);
			jPanel.add(getJButton1(), null);
			jPanel.add(getJButton(), null);
			jPanel.add(getJButton3(), null);
			jPanel.add(getJButton7(), null);
		}
		return jPanel;
	}

	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButton() {
		if (jButton == null) {
			jButton = new javax.swing.JButton();
			jButton.setText("save values");
			jButton
					.setToolTipText("save values of the length measurement in a text file");
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					FileWriter file;
					try {
						file = new FileWriter(Pfad + File.separator + Dateiname
								+ ".txt");
						file.write("sprout\tbranches\tlength\timage\n");
						file.write(jTextArea.getText());
						file.write("\n");
						file.close();
						System.out.println("File " + Dateiname
								+ ".txt was generated");
					} catch (IOException ioe) {
						System.out.println("Error: File *.txt NOT created");
					}
					if (jCheckBox2.isSelected() && (serieGeladen == true)) {
						// if working with image series...
						FileWriter file_XY_Values;
						try {
							file_XY_Values = new FileWriter(Pfad
									+ File.separator + "XY_Values" + Dateiname
									+ ".txt");
							gc.setTimeInMillis(System.currentTimeMillis());
							file_XY_Values.write("Datum: "
									+ gc.get(Calendar.DATE) + "."
									+ (gc.get(Calendar.MONTH) + 1) + "."
									+ gc.get(Calendar.YEAR) + "\n");
							file_XY_Values.write("Verwendetes Bild: "
									+ geladenesBild.getParent()
									+ File.separator + geladenesBild.getName()
									+ " bis " + letztesBild.getName() + "\n");
							file_XY_Values.write("\n");
							file_XY_Values.write("zaehler" + "\t" + "X1" + "\t"
									+ "Y1" + "\t" + "X2" + "\t" + "Y2" + "\n");
							file_XY_Values.write(myjScrollPane.getXYValues());
							file_XY_Values.close();
							System.out.println("File XY_Values" + Dateiname
									+ ".txt was generated");
						} catch (IOException ioe) {
							System.out.println("File *.txt can't be created");
						}
					}
				}
			});
		}
		return jButton;
	}

	/**
	 * This method initializes jTextArea
	 * 
	 * @return javax.swing.JTextArea
	 */
	private javax.swing.JTextArea getJTextArea() {
		if (jTextArea == null) {
			jTextArea = new javax.swing.JTextArea();
			// jTextArea.setPreferredSize(new java.awt.Dimension(220, 100));
			jTextArea.setTabSize(8);
		}
		return jTextArea;
	}

	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private javax.swing.JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new javax.swing.JScrollPane();
			jScrollPane.setViewportView(getmyJScrollPane());
		}
		return jScrollPane;
	}

	private javax.swing.JScrollPane getJScrollPane2() {
		if (jScrollPane2 == null) {
			jScrollPane2 = new javax.swing.JScrollPane();
			jScrollPane2.setViewportView(getJTextArea());
			jScrollPane2.setPreferredSize(new Dimension(220, 60));
		}
		return jScrollPane2;
	}

	/**
	 * This method initializes jButton1
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButton1() {
		if (jButton1 == null) {
			jButton1 = new javax.swing.JButton();
			jButton1.setText("load image");
			jButton1.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					// TODO Auto-generated Event stub actionPerformed()
					;
					// if (jFileChooser == null) {
					// jFileChooser = new JFileChooser();
					// }
					// if (currentPath != null) {
					// jFileChooser.setCurrentDirectory(currentPath);
					// }
					//
					// jFileChooser.setFileFilter(new myFileFilter2());
					// jFileChooser.showOpenDialog(new JFrame());
					// geladenesBild = jFileChooser.getSelectedFile();
					// setTitle("aktuelles Bild: " + geladenesBild.getName());
					// Dateiname =
					// geladenesBild.getName().substring(
					// 0,
					// geladenesBild.getName().toString().length() - 4);
					// System.out.println("geladenes Bild " + Dateiname);
					// Pfad = geladenesBild.getParent();
					// System.out.println("Pfad: " + Pfad);
					// myjScrollPane.setImage(geladenesBild.toString(),
					// Dateiname);
					// myjScrollPane.setSize(myjScrollPane.getPreferredSize());
					// myjScrollPane.repaint();
					// jButton7.setEnabled(true);
				}
			});
		}
		return jButton1;
	}

	/**
	 * This method initializes jButton2
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButton2() {
		if (jButton2 == null) {
			jButton2 = new javax.swing.JButton();
			jButton2.setText("calibrate");
			jButton2.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					myjScrollPane.calibrate(Double.parseDouble(jTextField
							.getText()), Double.parseDouble(jTextField1
							.getText()), Double.parseDouble(jTextField2
							.getText()), Double.parseDouble(jTextField3
							.getText()));
					myjScrollPane.jFrame.requestFocus();
				}
			});
		}
		return jButton2;
	}

	/**
	 * This method initializes jButton3
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButton3() {
		if (jButton3 == null) {
			jButton3 = new javax.swing.JButton();
			jButton3.setText("save image");
			jButton3.setToolTipText("save the actually displayed image");
			jButton3.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (multiImage == false) {
						myjScrollPane.bildSpeichern(Pfad + File.separator
								+ "edit" + Dateiname + ".png");
					} else {
						Dateiname = myjScrollPane.getActualImageName()
								.substring(
										0,
										myjScrollPane.getActualImageName()
												.toString().length() - 4);
						myjScrollPane.bildSpeichern(Pfad + File.separator
								+ "edit" + Dateiname + ".png");
					}
				}
			});
		}
		return jButton3;
	}

	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel1() {
		if (jPanel1 == null) {
			GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
			gridBagConstraints21.gridx = 2;
			gridBagConstraints21.gridy = 0;
			jYAxis = new JLabel();
			jYAxis.setText("y-axis");
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.gridx = 1;
			gridBagConstraints11.gridy = 0;
			jXAxis = new JLabel();
			jXAxis.setText("x-axis");
			GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
			gridBagConstraints9.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints9.gridx = 3;
			gridBagConstraints9.gridy = 3;
			gridBagConstraints9.gridheight = 2;
			GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
			gridBagConstraints8.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints8.gridheight = 2;
			gridBagConstraints8.gridx = 2;
			gridBagConstraints8.gridy = 3;
			gridBagConstraints8.weightx = 0.0D;
			gridBagConstraints8.insets = new Insets(0, 0, 0, 0);
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints6.gridheight = 2;
			gridBagConstraints6.gridx = 2;
			gridBagConstraints6.gridy = 1;
			gridBagConstraints6.weightx = 0.0D;
			gridBagConstraints6.insets = new Insets(0, 0, 0, 0);
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints4.gridheight = 2;
			gridBagConstraints4.gridx = 1;
			gridBagConstraints4.gridy = 3;
			gridBagConstraints4.weightx = 0.0D;
			gridBagConstraints4.insets = new Insets(0, 0, 0, 0);
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.gridheight = 0;
			gridBagConstraints3.gridx = 3;
			gridBagConstraints3.gridy = 1;
			gridBagConstraints3.gridwidth = 0;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints2.gridx = 0;
			gridBagConstraints2.gridy = 3;
			gridBagConstraints2.anchor = GridBagConstraints.EAST;
			gridBagConstraints2.gridheight = 2;
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints1.gridheight = 2;
			gridBagConstraints1.gridx = 1;
			gridBagConstraints1.gridy = 1;
			gridBagConstraints1.weightx = 0.0D;
			gridBagConstraints1.insets = new Insets(0, 0, 0, 0);
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 1;
			gridBagConstraints.anchor = GridBagConstraints.EAST;
			gridBagConstraints.gridheight = 2;
			jPanel1 = new javax.swing.JPanel();
			jPanel1.setLayout(new GridBagLayout());
			jPanel1.setPreferredSize(new Dimension(246, 90));
			jPanel1.add(getJLabel(), gridBagConstraints);
			jPanel1.add(getJTextField(), gridBagConstraints1);
			jPanel1.add(getJLabel1(), gridBagConstraints2);
			jPanel1.add(getJPanel2(), gridBagConstraints3);
			jPanel1.add(getJTextField1(), gridBagConstraints4);
			jPanel1.add(getJTextField2(), gridBagConstraints6);
			jPanel1.add(getJTextField3(), gridBagConstraints8);
			jPanel1.add(getJButton2(), gridBagConstraints9);
			jPanel1.add(jXAxis, gridBagConstraints11);
			jPanel1.add(jYAxis, gridBagConstraints21);
		}
		return jPanel1;
	}

	/**
	 * This method initializes jTextField
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextField() {
		if (jTextField == null) {
			jTextField = new javax.swing.JTextField();
			jTextField.setPreferredSize(new java.awt.Dimension(50, 20));
			jTextField.setName("kali_Pix_X");
		}
		return jTextField;
	}

	/**
	 * This method initializes jTextField1
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextField1() {
		if (jTextField1 == null) {
			jTextField1 = new javax.swing.JTextField();
			jTextField1.setPreferredSize(new java.awt.Dimension(50, 20));
			jTextField1.setName("kali_Laenge_X");
		}
		return jTextField1;
	}

	/**
	 * This method initializes jLabel
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel() {
		if (jLabel == null) {
			jLabel = new javax.swing.JLabel();
			jLabel.setText("pixels:");
		}
		return jLabel;
	}

	/**
	 * This method initializes jLabel1
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel1() {
		if (jLabel1 == null) {
			jLabel1 = new javax.swing.JLabel();
			jLabel1.setText("unit:");
		}
		return jLabel1;
	}

	/**
	 * This method initializes jPanel2
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel2() {
		if (jPanel2 == null) {
			jPanel2 = new javax.swing.JPanel();
			java.awt.GridLayout layGridLayout1 = new java.awt.GridLayout();
			layGridLayout1.setRows(1);
			layGridLayout1.setColumns(2);
			jPanel2.setLayout(layGridLayout1);
		}
		return jPanel2;
	}

	/**
	 * This method initializes jTextField2
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextField2() {
		if (jTextField2 == null) {
			jTextField2 = new javax.swing.JTextField();
			jTextField2.setPreferredSize(new java.awt.Dimension(50, 20));
			jTextField2.setName("kali_Pix_Y");
		}
		return jTextField2;
	}

	/**
	 * This method initializes jTextField3
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextField3() {
		if (jTextField3 == null) {
			jTextField3 = new javax.swing.JTextField();
			jTextField3.setPreferredSize(new java.awt.Dimension(50, 20));
			jTextField3.setName("kali_Laenge_Y");
		}
		return jTextField3;
	}

	/**
	 * This method initializes jJMenuBar
	 * 
	 * @return javax.swing.JMenuBar
	 */
	private javax.swing.JMenuBar getJJMenuBar() {
		if (jJMenuBar == null) {
			jJMenuBar = new javax.swing.JMenuBar();
			jJMenuBar.add(getJMenu());
			jJMenuBar.add(getJMenu3());
		}
		return jJMenuBar;
	}

	private void setKalibration() {
		jTextField.setText(kalibrierung.getX_Pixel());
		jTextField1.setText(kalibrierung.getX_Laenge());
		jTextField2.setText(kalibrierung.getY_Pixel());
		jTextField3.setText(kalibrierung.getY_Laenge());
	}

	/**
	 * This method initializes jButton4
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButton4() {
		if (jButton4 == null) {
			jButton4 = new javax.swing.JButton();
			jButton4.setText("load series");
			jButton4.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					;
					// multiImage = true;
					// if (jFileChooser == null) {
					// jFileChooser = new JFileChooser();
					// }
					// if (currentPath != null) {
					// jFileChooser.setCurrentDirectory(currentPath);
					// }
					// jFileChooser.setFileFilter(new myFileFilter2());
					// jFileChooser.setMultiSelectionEnabled(true);
					// jFileChooser.showOpenDialog(new JFrame());
					// bilder = jFileChooser.getSelectedFiles();
					// geladenesBild = bilder[0];
					// letztesBild = bilder[bilder.length - 1];
					// myjScrollPane.setMultiFile(bilder);
					// setTitle("aktuelles Bild: " + geladenesBild.getName());
					// Dateiname =
					// geladenesBild.getName().substring(
					// 0,
					// geladenesBild.getName().toString().length() - 4);
					// System.out.println("geladenes Bild " + Dateiname);
					// Pfad = geladenesBild.getParent();
					// System.out.println("Pfad: " + Pfad);
					// myjScrollPane.setImage(geladenesBild.toString(),
					// Dateiname);
					// myjScrollPane.setSize(myjScrollPane.getPreferredSize());
					// myjScrollPane.repaint();
					// serieGeladen = true;
					// jCheckBox2.setEnabled(true);
					// jCheckBox2.setSelected(true);
					// jButton7.setEnabled(true);
				}
			});
		}
		return jButton4;
	}

	/**
	 * This method initializes jMenu3
	 * 
	 * @return javax.swing.JMenu
	 */
	private javax.swing.JMenu getJMenu3() {
		if (jMenu3 == null) {
			jMenu3 = new javax.swing.JMenu();
			jMenu3.add(getJMenuItem18());
			jMenu3.setText("options");
		}
		return jMenu3;
	}

	/**
	 * This method initializes jMenuItem18
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private javax.swing.JMenuItem getJMenuItem18() {
		if (jMenuItem18 == null) {
			jMenuItem18 = new javax.swing.JMenuItem();
			jMenuItem18.setText("properties");
			jMenuItem18.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (jFrame == null) {
						jFrame = getJFrame();
					}
					jFrame.setVisible(true);
				}
			});
		}
		return jMenuItem18;
	}

	/**
	 * This method initializes jContentPane1
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane1() {
		if (jContentPane1 == null) {
			jContentPane1 = new javax.swing.JPanel();
			jContentPane1.setLayout(new java.awt.BorderLayout());
			jContentPane1.add(getJTabbedPane(), java.awt.BorderLayout.CENTER);
		}
		return jContentPane1;
	}

	/**
	 * This method initializes jFrame
	 * 
	 * @return javax.swing.JFrame
	 */
	private javax.swing.JFrame getJFrame() {
		if (jFrame == null) {
			jFrame = new javax.swing.JFrame();
			jFrame.setContentPane(getJContentPane1());
			jFrame.setSize(404, 136);
			jFrame.setTitle("properties");
			jFrame.setResizable(true);
		}
		return jFrame;
	}

	/**
	 * This method initializes jTabbedPane
	 * 
	 * @return javax.swing.JTabbedPane
	 */
	private javax.swing.JTabbedPane getJTabbedPane() {
		if (jTabbedPane == null) {
			jTabbedPane = new javax.swing.JTabbedPane();
			jTabbedPane.addTab(null, null, getJPanel5(), null);
			jTabbedPane.addTab(null, null, getJPanel3(), null);
			jTabbedPane.addTab(null, null, getJPanel4(), null);
			jTabbedPane.addTab(null, null, getJPanel6(), null);
			jTabbedPane.setTitleAt(0, "global");
			jTabbedPane.setTitleAt(1, "box size");
			jTabbedPane.setTitleAt(2, "save changes");
			jTabbedPane.setTitleAt(3, "path");
		}
		return jTabbedPane;
	}

	/**
	 * This method initializes jPanel3
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel3() {
		if (jPanel3 == null) {
			jPanel3 = new javax.swing.JPanel();
			jPanel3.setLayout(new java.awt.FlowLayout());
			jPanel3.add(getJLabel4(), null);
			jPanel3.add(getJTextField4(), null);
			jPanel3.add(getJLabel5(), null);
			jPanel3.add(getJTextField5(), null);
			jPanel3.add(getJButton5(), null);
		}
		return jPanel3;
	}

	/**
	 * This method initializes jTextField4
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextField4() {
		if (jTextField4 == null) {
			jTextField4 = new javax.swing.JTextField();
			jTextField4.setPreferredSize(new java.awt.Dimension(20, 20));
			jTextField4.setName("jTextField4");
			jTextField4.setText("");
		}
		return jTextField4;
	}

	/**
	 * This method initializes jLabel4
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel4() {
		if (jLabel4 == null) {
			jLabel4 = new javax.swing.JLabel();
			jLabel4.setText("width:");
			jLabel4.setName("jLabel4");
		}
		return jLabel4;
	}

	/**
	 * This method initializes jLabel5
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel5() {
		if (jLabel5 == null) {
			jLabel5 = new javax.swing.JLabel();
			jLabel5.setText("height:");
			jLabel5.setName("jLabel5");
		}
		return jLabel5;
	}

	/**
	 * This method initializes jTextField5
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextField5() {
		if (jTextField5 == null) {
			jTextField5 = new javax.swing.JTextField();
			jTextField5.setPreferredSize(new java.awt.Dimension(20, 20));
			jTextField5.setName("jTextField5");
			jTextField5.setText("");
		}
		return jTextField5;
	}

	/**
	 * This method initializes jButton5
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButton5() {
		if (jButton5 == null) {
			jButton5 = new javax.swing.JButton();
			jButton5.setText("apply");
			jButton5.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					myjScrollPane.setBox(Integer
							.parseInt(jTextField4.getText()), Integer
							.parseInt(jTextField5.getText()));
				}
			});
		}
		return jButton5;
	}

	/**
	 * This method initializes jPanel4
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel4() {
		if (jPanel4 == null) {
			jPanel4 = new javax.swing.JPanel();
			jPanel4.add(getJButton6(), null);
		}
		return jPanel4;
	}

	/**
	 * This method initializes jButton6
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButton6() {
		if (jButton6 == null) {
			jButton6 = new javax.swing.JButton();
			jButton6.setText("save changes");
			jButton6.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					;
					FileWriter config;
					try {
						config = new FileWriter("auswertung.cfg");
						config.write("# Diese Datei nicht verndern...\n");
						config.write("Box_Breite: " + jTextField4.getText()
								+ "\n");
						config.write("Box_Hoehe: " + jTextField5.getText()
								+ "\n");
						if (jCheckBox1.isSelected()) {
							config.write("Kontrollfenster zeigen: 1\n");
						} else {
							config.write("Kontrollfenster zeigen: 0\n");
						}
						config
								.write("# Die (X,Y)-Werte koennen nur gespeichert werden, wenn eine Bildserie geladen wurde.\n");
						if (jCheckBox2.isSelected()) {
							config.write("(X,Y)-Werte speichern: 1\n");
						} else {
							config.write("(X,Y)-Werte speichern: 0\n");
						}
						config.write("Fenstergroesse X: " + getWidth() + "\n");
						config.write("Fenstergroesse Y: " + getHeight() + "\n");
						config.write("Kalibrierung: \n");
						config.write("Mikroskop: "
								+ kalibrierung.getMikroskop() + "\n");
						config.write("Vergroesserung: "
								+ kalibrierung.getVergroesserung() + "\n");
						if (currentPath != null) {
							config.write("CurrentPath: "
									+ currentPath.getAbsolutePath() + "\n");
						}
						config.write("LocationX: " + getFrameLocation().x
								+ "\n");
						config.write("LocationY: " + getFrameLocation().y
								+ "\n");
						config.close();
					} catch (IOException cfgio) {
						System.out
								.println("Konfigurationsdatei konnte nicht erstellt werden");
					}
				}
			});
		}
		return jButton6;
	}

	/**
	 * This method initializes jPanel5
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel5() {
		if (jPanel5 == null) {
			jPanel5 = new javax.swing.JPanel();
			java.awt.GridLayout layGridLayout11 = new java.awt.GridLayout();
			layGridLayout11.setRows(1);
			layGridLayout11.setColumns(2);
			layGridLayout11.setHgap(5);
			layGridLayout11.setVgap(5);
			jPanel5.setLayout(layGridLayout11);
			jPanel5.add(getJCheckBox1(), null);
			jPanel5.add(getJCheckBox2(), null);
		}
		return jPanel5;
	}

	/**
	 * This method initializes jCheckBox1
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private javax.swing.JCheckBox getJCheckBox1() {
		if (jCheckBox1 == null) {
			jCheckBox1 = new javax.swing.JCheckBox();
			jCheckBox1.setText("show control window");
			jCheckBox1.setSelected(true);
		}
		return jCheckBox1;
	}

	private void loadDefault() {
		boolean showDatenblatt = false;
		boolean mikroskop_set = false;
		boolean vergroesserung_set = false;
		String mikroskop = " ";
		String vergroesserung = " ";
		int fenster_width = 0;
		int fenster_height = 0;
		boolean b_fw = false;
		boolean b_fh = false;
		int box_width = 0;
		int box_height = 0;
		boolean b_bw = false;
		boolean b_bh = false;
		BufferedReader config_br = null;
		String config_str = null;
		boolean setLocationX = false;
		boolean setLocationY = false;
		int locationX = 0;
		int locationY = 0;
		if (config == null) {
			config = new File("auswertung.cfg");
		}
		config_str = " ";
		String subconfig_str = " ";
		try {
			config_br = new BufferedReader(new FileReader(config));
			while ((config_str = config_br.readLine()) != null) {
				if (config_str.startsWith("Box_Breite: ")) {
					subconfig_str = config_str.substring("Box_Breite: "
							.length());
					box_width = Integer.parseInt(subconfig_str);
					jTextField4.setText(subconfig_str);
					b_bw = true;

				} else if (config_str.startsWith("Box_Hoehe: ")) {
					subconfig_str = config_str
							.substring("Box_Hoehe: ".length());
					box_height = Integer.parseInt(subconfig_str);
					jTextField5.setText(subconfig_str);
					b_bh = true;
				} else if (config_str.startsWith("Kontrollfenster zeigen: ")) {
					subconfig_str = config_str
							.substring("Kontrollfenster zeigen: ".length());
					if (subconfig_str.equalsIgnoreCase("1")) {
						myjScrollPane.showControl(true);
						jCheckBox1.setSelected(true);
					} else {
						myjScrollPane.showControl(false);
						jCheckBox1.setSelected(false);
					}
				} else if (config_str.startsWith("Fenstergroesse X: ")) {
					subconfig_str = config_str.substring("Fenstergroesse X: "
							.length());
					fenster_width = Integer.parseInt(subconfig_str);
					b_fw = true;
				} else if (config_str.startsWith("Fenstergroesse Y: ")) {
					subconfig_str = config_str.substring("Fenstergroesse Y: "
							.length());
					fenster_height = Integer.parseInt(subconfig_str);
					b_fh = true;
				} else if (config_str.startsWith("(X,Y)-Werte speichern: ")) {
					subconfig_str = config_str
							.substring("(X,Y)-Werte speichern: ".length());
					if (subconfig_str.equalsIgnoreCase("1")) {
						saveXY = true;
					} else {
						saveXY = false;
					}
				} else if (config_str.startsWith("Mikroskop: ")) {
					subconfig_str = config_str
							.substring("Mikroskop: ".length());
					mikroskop_set = true;
					mikroskop = subconfig_str;
					System.out.println(subconfig_str);
				} else if (config_str.startsWith("Vergroesserung: ")) {
					subconfig_str = config_str.substring("Vergroesserung: "
							.length());
					vergroesserung_set = true;
					vergroesserung = subconfig_str;
					System.out.println(subconfig_str);
				} else if (config_str.startsWith("CurrentPath: ")) {
					subconfig_str = config_str.substring("CurrentPath: "
							.length());
					currentPath = new File(subconfig_str);
					myjScrollPane.setCurrentPath(currentPath);
					jTextField6.setText(currentPath.getAbsolutePath());
					System.out.println(subconfig_str);
				} else if (config_str.startsWith("LocationX: ")) {
					subconfig_str = config_str
							.substring("LocationX: ".length());
					locationX = Integer.parseInt(subconfig_str);
					setLocationX = true;
				} else if (config_str.startsWith("LocationY: ")) {
					subconfig_str = config_str
							.substring("LocationY: ".length());
					locationY = Integer.parseInt(subconfig_str);
					setLocationY = true;
				}
				if (mikroskop_set && vergroesserung_set) {
					kalibrierung = new Calibration(mikroskop, vergroesserung);
					jTextField.setText(kalibrierung.getX_Pixel());
					jTextField1.setText(kalibrierung.getX_Laenge());
					jTextField2.setText(kalibrierung.getY_Pixel());
					jTextField3.setText(kalibrierung.getY_Laenge());
					jButton2.doClick();
				}
				if (b_bh && b_bw) {

					myjScrollPane.setBox(Integer
							.parseInt(jTextField4.getText()), Integer
							.parseInt(jTextField5.getText()));
				}
				if (b_fw && b_fh) {
					setSize(fenster_width, fenster_height);
				}
				if (setLocationX && setLocationY) {
					setLocation(locationX, locationY);
				}
			}
		} catch (IOException config_in) {
			System.out.println("Konfiguration konnte nicht geladen werden...");
		}

	}

	/**
	 * This method initializes jCheckBox2
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private javax.swing.JCheckBox getJCheckBox2() {
		if (jCheckBox2 == null) {
			jCheckBox2 = new javax.swing.JCheckBox();
			jCheckBox2.setText("save (x,y) values");
			jCheckBox2.setEnabled(false);
			jCheckBox2
					.setToolTipText("Erst moeglich, wenn mit Bildserien gearbeitet wird");
			jCheckBox2.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					saveXY = jCheckBox2.isSelected();
				}
			});
		}
		return jCheckBox2;
	}

	/**
	 * This method initializes jPanel6
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel6() {
		if (jPanel6 == null) {
			jPanel6 = new javax.swing.JPanel();
			jPanel6.add(getJLabel6(), null);
			jPanel6.add(getJTextField6(), null);
		}
		return jPanel6;
	}

	/**
	 * This method initializes jLabel6
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel6() {
		if (jLabel6 == null) {
			jLabel6 = new javax.swing.JLabel();
			jLabel6.setText("path:");
		}
		return jLabel6;
	}

	/**
	 * This method initializes jTextField6
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextField6() {
		if (jTextField6 == null) {
			jTextField6 = new javax.swing.JTextField();
			jTextField6.setPreferredSize(new java.awt.Dimension(200, 20));
			jTextField6.addCaretListener(new javax.swing.event.CaretListener() {
				public void caretUpdate(javax.swing.event.CaretEvent e) {
					// TODO Auto-generated Event stub caretUpdate()
					currentPath = new File(jTextField6.getText());
					myjScrollPane.setCurrentPath(currentPath);
				}
			});
		}
		return jTextField6;
	}

	/**
	 * This method initializes jButton7
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButton7() {
		if (jButton7 == null) {
			jButton7 = new javax.swing.JButton();
			jButton7.setText("count pixels");
			jButton7.setToolTipText("count the number of black pixels");
			jButton7.setEnabled(false);
			jButton7.setVisible(false);
			jButton7.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					FileWriter file2;
					if (multiImage == true) {
						for (int i = 0; i < bilder.length; i++) {
							myjScrollPane.setImage(bilder[i].toString(),
									Dateiname);
							myjScrollPane.setBildX(i);
							Dateiname = myjScrollPane.getActualImageName()
									.substring(
											0,
											myjScrollPane.getActualImageName()
													.toString().length() - 4);
							try {
								file2 = new FileWriter(Pfad + File.separator
										+ Dateiname + ".txt");
								file2.write(myjScrollPane.countPixels() + "\t"
										+ Dateiname + "\n");
								file2.close();
								System.out.println("Datei pixel" + Dateiname
										+ ".txt wurde erstellt");
							} catch (IOException ioe) {
								System.out
										.println("Datei *.txt konnte nicht erstellt werden...");
							}
							System.out.println("fertig...");
						}
					} else {
						;
						try {
							;
							file2 = new FileWriter(Pfad + File.separator
									+ Dateiname + ".txt");
							file2.write(myjScrollPane.countPixels() + "\t"
									+ Dateiname + "\n");
							file2.close();
							System.out.println("Datei pixel" + Dateiname
									+ ".txt wurde erstellt");
						} catch (IOException ioe) {
							System.out
									.println("Datei *.txt konnte nicht erstellt werden...");
						}
						System.out.println("fertig...");
					}
				}
			});
		}
		return jButton7;
	}

	private Point getFrameLocation() {
		return this.getLocationOnScreen();
	}

	private void setFrameLocation(int x, int y) {
		this.setLocation(x, y);
	}
} // @jve:visual-info decl-index=0 visual-constraint="10,10"

class Calibration {
	private String mikroskop = null;

	private String vergroesserung = null;

	public Calibration(String mikroskop, String vergroesserung) {
		this.mikroskop = mikroskop;
		this.vergroesserung = vergroesserung;
	}

	public String getX_Pixel() {
		return "10";
	}

	public String getX_Laenge() {
		return "10";
	}

	public String getY_Pixel() {
		return "10";
	}

	public String getY_Laenge() {
		return "10";
	}

	public String getMikroskop() {
		return "name of the microscope";
	}

	public String getVergroesserung() {
		return "magnification";
	}
}

class MyJScrollPane extends JScrollPane {

	private static final long serialVersionUID = 1L;

	private Measure parentWindow = null;

	private int imageWidth = 0;

	private int imageHeight = 0;

	private File currentPath = null;

	private int box_breite = 4;

	private int box_hoehe = 4;

	private int box_breite_halb = 2;

	private int box_hoehe_halb = 2;

	private File[] bilder = null;

	private int nBilder = 0;

	private boolean BilderSerie = false;

	private int bildX = 0;

	private String xy_Werte = null;

	// load the preferences
	private JFileChooser jFileChooser = null;

	private File txtFile_in = null;

	private BufferedReader txtFile_BR = null;

	private ButtonGroup bg_voreinstellung = null;

	private boolean endpunkt_voreinstellung = false;

	private int zaehler = 0;

	/**
	 * @param endpunkte
	 *            number of endpoints
	 * @param verzweigungen =
	 *            number of branches: endpunkte -1
	 */
	private int endpunkte = 0;

	private int verzweigungen = 0;

	/**
	 * @param v
	 *            vector to store myPixel-objects
	 */
	private Vector<MyPixel> v = null;

	private MyPixel mypixel = null;

	private MyPixel mypixel_last = null;

	private MyPixel verzweigungspunkt = null;

	private boolean endpunkt_erreicht = false;

	private MyPixel myPixelElement = null;

	private boolean verzweigungspunkt_definieren = false;

	private String punktArt = " ";

	private ButtonGroup buttongroup = null;

	// calibration
	private double n_Pixel_X;

	private double n_Laenge_X;

	private double n_Pixel_Y;

	private double n_Laenge_Y;

	private double gemessene_Laenge_X;

	private double gemessene_Laenge_Y;

	private double gemessene_Laenge;

	private int dx, dy;

	// true if the software is calibrated
	public boolean bereits_kalibriert = false;

	private Image bufferedImage = null;

	private Graphics bufferedGraphics = null;

	/**
	 * @param oImage
	 *            original image
	 * @param gImage
	 *            graphics-object of the original image
	 * @param ausgabeFenster
	 *            displays the obtained values
	 */
	public Image oImage = null;

	public Graphics gImage = null;

	private JTextArea ausgabeFenster = null;

	// coordinates of selected pixels
	int x1 = 0;

	int x2 = 0;

	int y1 = 0;

	int y2 = 0;

	// true if pixels (x1,x2,y1,y2) are defined
	boolean xs1 = false;

	boolean xs2 = false;

	boolean ys1 = false;

	boolean ys2 = false;

	public javax.swing.JFrame jFrame = null;

	/**
	 * jFrame fuer die Eingabe der Daten
	 */
	private javax.swing.JFrame jFrame_daten = null;

	/**
	 * daten_gesetzt == true, wenn die Daten der Maus gespeichert wurden
	 */
	private boolean daten_gesetzt = false;

	private String comment = null; // @jve:decl-index=0:

	// @jve:visual-info decl-index=0 visual-constraint="322,1"
	private javax.swing.JPanel jContentPane = null;

	private javax.swing.JPanel jPanel = null;

	private javax.swing.JRadioButton jRadioButton = null;

	private javax.swing.JRadioButton jRadioButton1 = null;

	private javax.swing.JRadioButton jRadioButton3 = null;

	private javax.swing.JRadioButton jRadioButton4 = null;

	private javax.swing.JLabel jLabel = null;

	private javax.swing.JRadioButton jRadioButton2 = null;

	private javax.swing.JRadioButton jRadioButton5 = null;

	private Measure measure = null;

	/**
	 * This is the default constructor
	 */
	public MyJScrollPane() {
		super();
		initialize();
	}

	public MyJScrollPane(Measure measure) {
		super();
		this.measure = measure;
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(300, 200);
		this.setFocusable(true);
		this.addMouseListener(new java.awt.event.MouseListener() {
			public void mouseClicked(java.awt.event.MouseEvent e) {
				requestFocusInWindow();
				if (bereits_kalibriert == false) {
					System.out
							.println("Please calibrate the software first...");
				} else {
					if (endpunkt_voreinstellung == true) {
						if (xs1 && ys1 && !xs2 && !ys2) {
							x2 = e.getX();
							y2 = e.getY();
							punktArt = "Endpunkt";
							setPunkt();
							repaint();
							dx = Math.abs(x2 - x1);
							dy = Math.abs(y2 - y1);
							gemessene_Laenge_X = umrechnen_X(dx);
							gemessene_Laenge_Y = umrechnen_Y(dy);
							gemessene_Laenge = Laenge_berechnen(
									gemessene_Laenge_X, gemessene_Laenge_Y);
							bufferedGraphics.drawLine(x1, y1, x2, y2);
							repaint();
							xs2 = true;
							ys2 = true;
						}
						if (!xs1 && !ys1 && !xs2 && !ys2) {
							zaehler++;
							xs1 = true;
							ys1 = true;
							x1 = e.getX();
							y1 = e.getY();
							bufferedGraphics.setColor(Color.orange);
							bufferedGraphics.drawString(
									String.valueOf(zaehler), x1 + 10, y1 + 10);
							punktArt = "Startpunkt";
							setPunkt();
							repaint();
						}
						if (xs1 && xs2 && ys1 && ys2) {
							if (xy_Werte == null) {
								xy_Werte = zaehler + "\t" + x1 + "\t" + y1
										+ "\t" + x2 + "\t" + y2 + "\n";
							} else {
								xy_Werte = xy_Werte + zaehler + "\t" + x1
										+ "\t" + y1 + "\t" + x2 + "\t" + y2
										+ "\n";
							}
							xs1 = false;
							xs2 = false;
							ys1 = false;
							ys2 = false;
							x1 = 0;
							x2 = 0;
							y1 = 0;
							y2 = 0;
							String ergebnis = String.valueOf(Math
									.round(gemessene_Laenge));
							ausgabeFenster.setText(ausgabeFenster.getText()
									+ zaehler + "\t" + "0" + "\t" + ergebnis
									+ "\t" + comment + "\n");
							gemessene_Laenge_X = 0;
							gemessene_Laenge_Y = 0;
							gemessene_Laenge = 0;
							verzweigungen = 0;
							endpunkte = 0;
						}

					} else {
						if (verzweigungspunkt_definieren == false) {
							if (e.getButton() == 1) {
								if (xs1 && ys1 && !xs2 && !ys2) {
									x2 = e.getX();
									y2 = e.getY();
									mypixel = new MyPixel(x2, y2, punktArt,
											mypixel_last);
									v.addElement(mypixel);
									setPunkt();
									repaint();
									dx = Math.abs(x2 - x1);
									dy = Math.abs(y2 - y1);
									gemessene_Laenge_X = umrechnen_X(dx);
									gemessene_Laenge_Y = umrechnen_Y(dy);
									gemessene_Laenge = gemessene_Laenge
											+ Laenge_berechnen(
													gemessene_Laenge_X,
													gemessene_Laenge_Y);

									mypixel_last = (MyPixel) v.lastElement();
									bufferedGraphics.drawLine(x1, y1, x2, y2);
									repaint();
									x1 = x2;
									y1 = y2;
									if (verzweigungspunkt != null
											&& punktArt
													.equalsIgnoreCase("Endpunkt")) {
										mypixel_last = verzweigungspunkt;
										x1 = mypixel_last.getX();
										y1 = mypixel_last.getY();
										setPunktArt('1');
									}
								}
								if (!xs1 && !ys1 && !xs2 && !ys2) {
									zaehler++;
									v = new Vector<MyPixel>();
									xs1 = true;
									ys1 = true;
									x1 = e.getX();
									y1 = e.getY();
									bufferedGraphics.setColor(Color.orange);
									bufferedGraphics
											.drawString(
													String.valueOf(zaehler),
													x1 + 10, y1 + 10);
									bufferedGraphics.setColor(Color.yellow);
									punktArt = "Startpunkt";
									jRadioButton.setSelected(true);
									setPunkt();
									mypixel = new MyPixel(x1, y1, "Startpunkt");
									mypixel_last = mypixel;
									v.addElement(mypixel);
									setPunktArt('1');
									repaint();
								}
							}
						} else {
							x2 = e.getX();
							y2 = e.getY();
							for (int i = v.size() - 1; i >= 0; i--) {
								myPixelElement = (MyPixel) v.elementAt(i);
								if (equalPMausPPixel(x2, y2, myPixelElement)) {
									x2 = myPixelElement.getX();
									y2 = myPixelElement.getY();
									myPixelElement.setVerzweigungspunkt();
									setPunkt();
									repaint();
									x1 = x2;
									y1 = y2;
									mypixel_last = myPixelElement;
									verzweigungspunkt = mypixel_last;
									verzweigungspunkt_definieren = false;
									setPunktArt('1');
									break;
								}
							}
						}
						if (e.getButton() == 3) {
							xs1 = false;
							xs2 = false;
							ys1 = false;
							ys2 = false;
							x1 = 0;
							x2 = 0;
							y1 = 0;
							y2 = 0;
							verzweigungen = endpunkte - 1;
							if (verzweigungen == -1)
								verzweigungen = 0;
							String ergebnis = String.valueOf(Math
									.round(gemessene_Laenge));
							ausgabeFenster.setText(ausgabeFenster.getText()
									+ zaehler + "\t" + verzweigungen + "\t"
									+ ergebnis + "\t" + comment + "\n");
							gemessene_Laenge_X = 0;
							gemessene_Laenge_Y = 0;
							gemessene_Laenge = 0;
							verzweigungen = 0;
							endpunkte = 0;
						}
					}
				}
			}

			public void mouseEntered(java.awt.event.MouseEvent e) {
			}

			public void mouseExited(java.awt.event.MouseEvent e) {
			}

			public void mousePressed(java.awt.event.MouseEvent e) {
			}

			public void mouseReleased(java.awt.event.MouseEvent e) {
			}
		});
		this.addKeyListener(new java.awt.event.KeyAdapter() {
			public void keyTyped(java.awt.event.KeyEvent e) {
				// TODO Auto-generated Event stub keyTyped()
				if (BilderSerie == true && e.getKeyChar() == ' ') {
					bildX++;
					if (bildX < nBilder) {
						// alte Zeile vor 20060613
						// setImage(bilder[bildX].toString(), comment);

						setImage(bilder[bildX].toString(), bilder[bildX]
								.getName());
						// String dateikennung =
						// bilder[bildX].getName().replaceAll(".png","");
						// int vorkommen = dateikennung.indexOf("_");
						// String dateikennung2 =
						// dateikennung.substring(0,vorkommen);
						// System.out.println("Vorkommen: " + dateikennung + " "
						// + vorkommen + " " + dateikennung2);

						// for (int a = 0 ; a < 10; a++){
						// dateikennung =
						// dateikennung.replaceAll(String.valueOf(a),"");
						// }
						// System.out.println("aa. " + dateikennung);
						// setImage(bilder[bildX].toString(),
						// bilder[bildX].getName());
						// setImage(bilder[bildX].toString(), dateikennung);
						repaint();
					} else {
						System.out.println("fertig");
					}
				}
			}

			public void keyPressed(java.awt.event.KeyEvent e) {
				// TODO Auto-generated Event stub keyPressed()
				setPunktArt(e.getKeyChar());
			}
		});

		this.jFrame = this.getJFrame();
		buttongroup = new ButtonGroup();
		buttongroup.add(jRadioButton);
		buttongroup.add(jRadioButton1);
		buttongroup.add(jRadioButton3);
		buttongroup.add(jRadioButton4);
	}

	public void paint(Graphics g) {
		if (bufferedImage != null) {
			g.drawImage(bufferedImage, 0, 0, this);
		}
	}

	public void update(Graphics g) {
		paint(g);
	}

	public void setImage(String s, String Dateiname) {
		oImage = null;
		oImage = this.getToolkit().getImage(s);
		// alte Zeile vor 20060621
		comment = Dateiname;
		// neu seit 20060621
		// String aa = Dateiname;
		// int vorkommen = aa.indexOf("_");
		// comment = aa.substring(0, vorkommen);

		MediaTracker mt = new MediaTracker(this);
		mt.addImage(oImage, 0);
		try {
			mt.waitForAll();
		} catch (InterruptedException e) {
			;
		}
		if (bufferedImage == null) {
			bufferedImage = this.createImage(oImage.getWidth(this), oImage
					.getHeight(this));
			bufferedGraphics = bufferedImage.getGraphics();
			bufferedGraphics.setColor(Color.yellow);
		}
		imageWidth = oImage.getWidth(this);
		imageHeight = oImage.getHeight(this);
		bufferedGraphics.drawImage(oImage, 0, 0, this);
		setPreferredSize(new Dimension(oImage.getWidth(this), oImage
				.getHeight(this)));
		System.out.println(getPreferredSize().toString());
	}

	public Dimension getPreferredSize() {
		if (oImage != null) {
			return new Dimension(oImage.getWidth(this), oImage.getHeight(this));
		} else {
			return new Dimension(1300, 1030);
		}
	}

	public void ausgabeFenster(JTextArea ausgabe) {
		this.ausgabeFenster = ausgabe;
	}

	public void bildSpeichern(String s) {
		try {
			ImageIO.write((RenderedImage) bufferedImage, "png", new File(s));
			System.out.println("Datei wurde erstellt");
		} catch (IOException ioe) {
			System.out.println("Bild konnte nicht erstellt werden...");
		}
	}

	public void calibrate(double n_Pixel_X, double n_Laenge_X,
			double n_Pixel_Y, double n_Laenge_Y) {
		if (bereits_kalibriert == false) {
			this.n_Pixel_X = n_Pixel_X;
			this.n_Laenge_X = n_Laenge_X;
			this.n_Pixel_Y = n_Pixel_Y;
			this.n_Laenge_Y = n_Laenge_Y;
		} else {
			System.out.println("bereits kalibriert; verwende: X:"
					+ this.n_Pixel_X + " Pixel entsprechen: " + this.n_Laenge_X
					+ "\nY: " + this.n_Pixel_Y + " entsprechen: "
					+ this.n_Laenge_Y);
		}
		bereits_kalibriert = true;
	}

	/**
	 * berechnet die gemessene Laenge in X-Richtung
	 * 
	 * @param deltaX
	 * @return
	 */
	private double umrechnen_X(int deltaX) {
		return (double) deltaX * n_Laenge_X / n_Pixel_X;
	}

	/**
	 * berechnet die gemessene Laenge in Y-Richtung
	 * 
	 * @param deltaY
	 * @return
	 */
	private double umrechnen_Y(int deltaY) {
		return (double) deltaY * n_Laenge_Y / n_Pixel_Y;
	}

	/**
	 * Satz des Pythagoras Berechnet die resultierende Laenge aus den Laengen in
	 * X- und Y- Richtung
	 * 
	 * @param Laenge_X
	 * @param Laenge_Y
	 * @return
	 */
	private double Laenge_berechnen(double Laenge_X, double Laenge_Y) {
		return Math.sqrt((Laenge_X * Laenge_X) + (Laenge_Y * Laenge_Y));
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(new java.awt.BorderLayout());
			jContentPane.add(getJPanel(), java.awt.BorderLayout.CENTER);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jFrame
	 * 
	 * @return javax.swing.JFrame
	 */
	private javax.swing.JFrame getJFrame() {
		if (jFrame == null) {
			jFrame = new javax.swing.JFrame();
			jFrame.setContentPane(getJContentPane());
			jFrame.setSize(130, 225);
			// jFrame.setSize(199, 225);
			jFrame.setVisible(true);
			// jFrame.pack();
			jFrame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					measure.dispose();
				}
			});
		}
		return jFrame;
	}

	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new javax.swing.JPanel();
			java.awt.FlowLayout layFlowLayout1 = new java.awt.FlowLayout();
			layFlowLayout1.setAlignment(java.awt.FlowLayout.LEFT);
			jPanel.setLayout(layFlowLayout1);
			jPanel.add(getJRadioButton(), null);
			jPanel.add(getJRadioButton1(), null);
			jPanel.add(getJRadioButton3(), null);
			jPanel.add(getJRadioButton4(), null);
			jPanel.add(getJLabel(), null);
			jPanel.add(getJRadioButton2(), null);
			jPanel.add(getJRadioButton5(), null);
			this.bg_voreinstellung = new ButtonGroup();
			this.bg_voreinstellung.add(this.jRadioButton2);
			this.bg_voreinstellung.add(this.jRadioButton5);
		}
		return jPanel;
	}

	/**
	 * This method initializes jRadioButton
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private javax.swing.JRadioButton getJRadioButton() {
		if (jRadioButton == null) {
			jRadioButton = new javax.swing.JRadioButton();
			jRadioButton.setText("start");
			jRadioButton.setEnabled(false);
			jRadioButton.setBackground(java.awt.Color.red);
		}
		return jRadioButton;
	}

	/**
	 * This method initializes jRadioButton1
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private javax.swing.JRadioButton getJRadioButton1() {
		if (jRadioButton1 == null) {
			jRadioButton1 = new javax.swing.JRadioButton();
			jRadioButton1.setText("middle [1]");
			jRadioButton1.setEnabled(false);
			jRadioButton1.setBackground(java.awt.Color.yellow);
		}
		return jRadioButton1;
	}

	/**
	 * This method initializes jRadioButton3
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private javax.swing.JRadioButton getJRadioButton3() {
		if (jRadioButton3 == null) {
			jRadioButton3 = new javax.swing.JRadioButton();
			jRadioButton3.setText("end [2]");
			jRadioButton3.setEnabled(false);
			jRadioButton3.setBackground(java.awt.Color.green);
			jRadioButton3.setActionCommand("Endpunkt [2]");
		}
		return jRadioButton3;
	}

	/**
	 * This method initializes jRadioButton4
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private javax.swing.JRadioButton getJRadioButton4() {
		if (jRadioButton4 == null) {
			jRadioButton4 = new javax.swing.JRadioButton();
			jRadioButton4.setText("branch [3]");
			jRadioButton4.setEnabled(false);
			jRadioButton4.setBackground(java.awt.Color.blue);
		}
		return jRadioButton4;
	}

	/**
	 * Wird durch Tastatureingaben ausgeloest und bestimmt die Variable
	 * punktArt.
	 * 
	 * @param s
	 */
	private void setPunktArt(char s) {
		switch (s) {
		case '0':
			this.punktArt = "Startpunkt";
			jRadioButton.setSelected(true);
			break;
		case '1':
			this.punktArt = "Mittelpunkt";
			jRadioButton1.setSelected(true);
			break;
		case '2':
			this.punktArt = "Endpunkt";
			this.endpunkte++;
			jRadioButton3.setSelected(true);
			break;
		case '3':
			this.verzweigungspunkt_definieren = true;
			this.punktArt = "Verzweigungspunkt";
			jRadioButton4.setSelected(true);
			break;
		default:
			this.punktArt = " ";
		}
	}

	public void setPunkt() {
		if (this.punktArt.equalsIgnoreCase("Startpunkt")) {
			bufferedGraphics.setColor(Color.red);
			bufferedGraphics.fillRect(x1 - box_breite_halb,
					y1 - box_hoehe_halb, box_breite, box_hoehe);
			bufferedGraphics.setColor(Color.yellow);
		} else if (this.punktArt.equalsIgnoreCase("Mittelpunkt")) {
			bufferedGraphics.setColor(Color.yellow);
			bufferedGraphics.fillRect(x2 - box_breite_halb,
					y2 - box_hoehe_halb, box_breite, box_hoehe);
			bufferedGraphics.setColor(Color.yellow);
		} else if (this.punktArt.equalsIgnoreCase("Verzweigungspunkt")) {
			bufferedGraphics.setColor(Color.blue);
			bufferedGraphics.fillRect(x2 - box_breite_halb,
					y2 - box_hoehe_halb, box_breite, box_hoehe);
			bufferedGraphics.setColor(Color.yellow);
		} else if (this.punktArt.equalsIgnoreCase("Endpunkt")) {
			this.endpunkt_erreicht = true;
			bufferedGraphics.setColor(Color.green);
			bufferedGraphics.fillRect(x2 - box_breite_halb,
					y2 - box_hoehe_halb, box_breite, box_hoehe);
			bufferedGraphics.setColor(Color.yellow);
		} else {
			;
		}
	}

	/**
	 * vergleicht die X- und Y- Koordinaten eines Punktes mit den Koordinaten
	 * eines Objektes vom Typ myPixel Ist der Abstand zwischen den Punkten
	 * kleiner als zehn Pixel, wird true zurueckgeliefert.
	 * 
	 * @param x_Maus
	 * @param y_Maus
	 * @param pixel
	 * @return
	 */
	private boolean equalPMausPPixel(int x_Maus, int y_Maus, MyPixel pixel) {
		if ((Math.abs(x_Maus - pixel.getX()) < 10)
				&& (Math.abs(y_Maus - pixel.getY()) < 10)) {
			return true;
		} else
			return false;
	}

	/**
	 * This method initializes jLabel
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel() {
		if (jLabel == null) {
			jLabel = new javax.swing.JLabel();
			jLabel.setText("presetting");
		}
		return jLabel;
	}

	/**
	 * This method initializes jRadioButton2
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private javax.swing.JRadioButton getJRadioButton2() {
		if (jRadioButton2 == null) {
			jRadioButton2 = new javax.swing.JRadioButton();
			jRadioButton2.setText("set endpoint");
		}
		return jRadioButton2;
	}

	/**
	 * This method initializes jRadioButton5
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private javax.swing.JRadioButton getJRadioButton5() {
		if (jRadioButton5 == null) {
			jRadioButton5 = new javax.swing.JRadioButton();
			jRadioButton5.setText("set middlepoint");
			jRadioButton5.setSelected(true);
			jRadioButton5.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					if (jRadioButton5.isSelected()) {
						System.out.println("Voreinstellung: Mittelpunkt");
						endpunkt_voreinstellung = false;
					} else {
						System.out.println("Voreinstellung: Endpunkt");
						endpunkt_voreinstellung = true;
					}
				}
			});
		}
		return jRadioButton5;
	}

	public void setMultiFile(File[] f) {
		bilder = f;
		BilderSerie = true;
		nBilder = bilder.length;
		jRadioButton2.setSelected(true);
	}

	public String getActualImageName() {
		return bilder[bildX].getName();
	}

	public String getXYValues() {
		if (xy_Werte == null) {
			return "only in single image mode";
		} else {
			return xy_Werte;
		}
	}

	public void setBox(int width, int height) {
		this.box_breite = width;
		this.box_hoehe = height;
		this.box_breite_halb = Math.round(this.box_breite / 2);
		this.box_hoehe_halb = Math.round(this.box_hoehe / 2);
	}

	public void showControl(boolean show) {
		jFrame.setVisible(show);
	}

	public void hideDatenblatt() {
		jFrame_daten.setVisible(false);
	}

	public void setCurrentPath(File cP) {
		currentPath = cP;
	}

	public int getImageWidth() {
		return imageWidth;
	}

	public int getImageHeight() {
		return imageHeight;
	}

	public String countPixels() {
		System.out.println("Count...");
		int[] pixels = new int[imageWidth * imageHeight];
		int blue = 0;
		int red = 0;
		int green = 0;
		PixelGrabber pg = new PixelGrabber(oImage, 0, 0, imageWidth,
				imageHeight, pixels, 0, imageWidth);
		try {
			pg.grabPixels();
		} catch (InterruptedException e) {
			System.err.println("interrupted waiting for pixels!");
		}
		int black = 0;
		int white = 0;
		for (int i = 0; i < pixels.length; i++) {
			blue = (pixels[i]) & 0xff;
			green = (pixels[i] >> 8) & 0xff;
			red = (pixels[i] >> 16) & 0xff;
			if (blue > 125 && green > 125 && red > 125) {
				white++;
			} else {
				black++;
			}
		}
		int gesamt = black + white;
		return new String(
		// "schwarz\tweiss\tgesamt\n"
				// + "#####\n"+
				black + "\t" + white + "\t" + gesamt);
	}

	public void setBildX(int i) {
		bildX = i;
	}

	public void setListener(WindowListener[] arg0) {
		for (int i = 0; i < arg0.length; i++) {
			jFrame.addWindowListener(arg0[i]);
		}
	}
}

class MyPixel {
	private int x = 0;
	private int y = 0;
	private boolean bearbeitet = false;

	private boolean Startpunkt = false;
	private boolean Mittelpunkt = false;
	private boolean Endpunkt = false;
	private boolean Verzweigungspunkt = false;
	private MyPixel Referenzpunkt = null;

	public MyPixel() {
		this.x = 0;
		this.y = 0;
		this.Startpunkt = false;
		this.Mittelpunkt = false;
		this.Endpunkt = false;
		this.Verzweigungspunkt = false;
		this.Referenzpunkt = null;
	}

	public MyPixel(int x, int y) {
		this.x = x;
		this.y = y;
		this.Startpunkt = false;
		this.Mittelpunkt = false;
		this.Endpunkt = false;
		this.Verzweigungspunkt = false;
		this.Referenzpunkt = null;
	}

	public MyPixel(int x, int y, String punktArt) {
		this.x = x;
		this.y = y;
		if (punktArt.equalsIgnoreCase("startpunkt")) {
			this.Startpunkt = true;
			this.Mittelpunkt = false;
			this.Endpunkt = false;
			this.Verzweigungspunkt = false;
		}
		if (punktArt.equalsIgnoreCase("mittelpunkt")) {
			this.Startpunkt = false;
			this.Mittelpunkt = true;
			this.Endpunkt = false;
			this.Verzweigungspunkt = false;
		}
		if (punktArt.equalsIgnoreCase("endpunkt")) {
			this.Startpunkt = false;
			this.Mittelpunkt = false;
			this.Endpunkt = true;
			this.Verzweigungspunkt = false;
		}
		if (punktArt.equalsIgnoreCase("verzweigungspunkt")) {
			this.Startpunkt = false;
			this.Mittelpunkt = false;
			this.Endpunkt = false;
			this.Verzweigungspunkt = true;
		}
		this.Referenzpunkt = null;
	}

	public MyPixel(int x, int y, String punktArt, MyPixel Referenzpunkt) {
		this.x = x;
		this.y = y;
		if (punktArt.equalsIgnoreCase("startpunkt")) {
			this.Startpunkt = true;
			this.Mittelpunkt = false;
			this.Endpunkt = false;
			this.Verzweigungspunkt = false;
		}
		if (punktArt.equalsIgnoreCase("mittelpunkt")) {
			this.Startpunkt = false;
			this.Mittelpunkt = true;
			this.Endpunkt = false;
			this.Verzweigungspunkt = false;
		}
		if (punktArt.equalsIgnoreCase("endpunkt")) {
			this.Startpunkt = false;
			this.Mittelpunkt = false;
			this.Endpunkt = true;
			this.Verzweigungspunkt = false;
		}
		if (punktArt.equalsIgnoreCase("verzweigungspunkt")) {
			this.Startpunkt = false;
			this.Mittelpunkt = false;
			this.Endpunkt = false;
			this.Verzweigungspunkt = true;
		}
		this.Referenzpunkt = Referenzpunkt;
	}

	public void setX(int x) {
		this.x = x;
	}

	public void setY(int y) {
		this.y = y;
	}

	public int getX() {
		return this.x;
	}

	public int getY() {
		return this.y;
	}

	public void setStartpunkt() {
		this.Startpunkt = true;
	}

	public void setMittelpunkt() {
		this.Mittelpunkt = true;
	}

	public void setEndpunkt() {
		this.Endpunkt = true;
	}

	public void setVerzweigungspunkt() {
		this.Endpunkt = false;
		this.Mittelpunkt = false;
		this.Startpunkt = false;
		this.Verzweigungspunkt = true;
	}

	public boolean isStartpunkt() {
		return this.Startpunkt;
	}

	public boolean isMittelpunkt() {
		return this.Mittelpunkt;
	}

	public boolean isEndpunkt() {
		return this.Endpunkt;
	}

	public boolean isVerzweigungspunkt() {
		return this.Verzweigungspunkt;
	}

	public void setReferenzpunkt(MyPixel mp) {
		this.Referenzpunkt = mp;
	}

	public MyPixel getReferenzpunkt() {
		return this.Referenzpunkt;
	}

	public void setBearbeitet(boolean b) {
		this.bearbeitet = b;
	}

	public boolean getBearbeitet() {
		return this.bearbeitet;
	}

	public String toString() {
		if (this.Startpunkt) {
			return new String("x=" + this.x + " y=" + this.y + " Startpunkt \n");
		} else if (this.Mittelpunkt) {
			return new String("x=" + this.x + " y=" + this.y
					+ " Mittelpunkt \nReferenzpunkt:"
					+ this.Referenzpunkt.toString() + "\n");
		} else if (this.Endpunkt) {
			return new String("x=" + this.x + " y=" + this.y
					+ " Endpunkt \nReferenzpunkt:"
					+ this.Referenzpunkt.toString());
		} else if (this.Verzweigungspunkt) {
			return new String("x=" + this.x + " y=" + this.y
					+ " Verzweigungspunkt " + this.bearbeitet
					+ "\nReferenzpunkt:" + this.Referenzpunkt.toString());
		} else {
			return new String("nicht definiert");
		}
	}
}
